﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.Collections;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public static string sectionControlName { get; set; }
        public static string sectionControlText { get; set; }

        private void btnSection_Click(object sender, EventArgs e)
        {
            sectionControlName = txtSectionControlName.Text;
            sectionControlText = txtSectionControlText.Text;
            SectionReport1 sectionReport = new SectionReport1();
            viewer1.LoadDocument(sectionReport);
        }

        GrapeCity.ActiveReports.PageReport pageReport;
        private void btnPage_Click(object sender, EventArgs e)
        {
            string file_name = @"..\..\PageReport1.rdlx";
            pageReport = new GrapeCity.ActiveReports.PageReport(new System.IO.FileInfo(file_name));
            if (txtPageControlName.Text != "" || txtPageControlText.Text != "")
            {
                GetPageControlByName(txtPageControlName.Text).Value = txtPageControlText.Text;
                GetPageControlByName(txtPageControlName.Text).Style.Color = GrapeCity.ActiveReports.Expressions.ExpressionInfo.FromString("Red");
            }
            GrapeCity.ActiveReports.Document.PageDocument pageDocument = new GrapeCity.ActiveReports.Document.PageDocument(pageReport);
            viewer1.LoadDocument(pageDocument);
        }

        #region Page Report Reflection Function
        GrapeCity.ActiveReports.PageReportModel.TextBox reportItem;
        public GrapeCity.ActiveReports.PageReportModel.TextBox GetPageControlByName(string Name)
        {
            object obj = pageReport.Report.Body.Components;
            FieldInfo[] fieldInfos = obj.GetType().GetFields(BindingFlags.NonPublic | BindingFlags.CreateInstance | BindingFlags.Instance | BindingFlags.InvokeMethod);
            dynamic repItems = fieldInfos[0].GetValue(obj);
            var count = ((ICollection)repItems).Count;
            for (int i = 0; i < count; i++)
            {
                if (repItems[i].Name == Name)
                {
                    reportItem = repItems[i];
                }
            }
            return reportItem;
        }
        #endregion
    }
}
